#!/bin/sh
# /etc/init.d/RadarOut
#
### BEGIN INIT INFO
# Provides:          RadarOut
# Required-Start:    $local_fs
# Required-Stop:     $local_fs
# Default-Start:     5
# Default-Stop:      0 6
# Short-Description: startupcounter
# Description:       Records number of entries into each run level to $logdirectory
### END INIT INFO

ALARM=4

set_gpio()
{
	if [ ! -d /sys/class/gpio/gpio$1 ]; then
		echo $1 > /sys/class/gpio/export
		echo out > /sys/class/gpio/gpio$1/direction
	fi
	
	echo $2 > /sys/class/gpio/gpio$1/value
}

case "$1" in
  high)
	set_gpio ${ALARM} 1
  ;;
  low)
	set_gpio ${ALARM} 0
  ;;
  toggle)
	while [ true ]
	do
		set_gpio ${ALARM} 0
		sleep 1;
		set_gpio ${ALARM} 1
		sleep 1;
	done
  ;;
  *)
	echo "Usage /etc/init.d/alarm.sh [high|low|toggle]"
	exit -1
  ;;
esac

exit 0
