#!/bin/bash

set -x
echo "Wifi Test"

BAUD="115200"
MATCHSTRING=" 0% packet loss"
TIMEOUT=10
TESTNAME="WIFI_PING"
PING_CMD="ping -c 5 -w 10 -I"

case "$1" in
	ping_test) #used when you are looping 2 serial ports together...
		if [ -z "$2" ]; then
		   INTERFACE="wlan0"
		else
		   INTERFACE=$2
		fi

		if [ -z "$3" ]; then
		   IP_ADDR=192.168.0.1
		else
		   IP_ADDR=$3
		fi

		if [ -z "$4" ]; then
		   RESET=""
		else
		   RESET=$4
		fi

		if [ -z "$5" ]; then
		   DEBUG=""
		else
		   DEBUG=$5
		fi
		
		
		COUNT_FILE=/var/volatile/${INTERFACE}.count
		FAILCOUNT_FILE=/var/volatile/${INTERFACE}.failcount
		PASSCOUNT_FILE=/var/volatile/${INTERFACE}.passcount

		if [ "$RESET" = "reset" ]; then
			echo 0 > $COUNT_FILE
			echo 0 > $FAILCOUNT_FILE
			echo 0 > $PASSCOUNT_FILE
		fi
		if [ -f $COUNT_FILE ]; then
			COUNT=`cat $COUNT_FILE`
		fi
		if [ -f $PASSCOUNT_FILE ]; then
			PASSCOUNT=`cat $PASSCOUNT_FILE`
		fi
		if [ -f $COUNT_FILE ]; then
			FAILCOUNT=`cat $FAILCOUNT_FILE`
		fi
		
		
        while [ 1 ]; do
			RESULT=`perl -e "alarm $TIMEOUT; exec @ARGV" "$PING_CMD $INTERFACE $IP_ADDR"`
			RESULT2=`echo $RESULT | grep "$MATCHSTRING"`
			COUNT=`expr $COUNT + 1`
			if [ "$RESULT2" ]; then  
				PASSCOUNT=`expr $PASSCOUNT + 1`
			else
				FAILCOUNT=`expr $FAILCOUNT + 1`
			fi
			echo $COUNT > $COUNT_FILE
			echo $PASSCOUNT > $PASSCOUNT_FILE
			echo $FAILCOUNT > $FAILCOUNT_FILE
			sleep $TIMEOUT
		done
        ;;
esac



