#!/bin/sh

### END INIT INFO

GPS_POWER=169
GPS_POWER_INT=81
GPS_POWER_FAULT_RST=175
GPS_POWER_SENSE=176

get_gpi()
{
	if [ ! -d /sys/class/gpio/gpio$1 ]; then
		echo $1
		echo $1 > /sys/class/gpio/export
		
	fi
	echo in > /sys/class/gpio/gpio$1/direction
	echo `cat /sys/class/gpio/gpio$1/value`
}
set_gpio()
{
	if [ ! -d /sys/class/gpio/gpio$1 ]; then
		echo $1 > /sys/class/gpio/export
	fi
	echo out > /sys/class/gpio/gpio$1/direction
	echo $2 > /sys/class/gpio/gpio$1/value
}

case "$1" in
  high)
	set_gpio ${GPS_POWER} 1
  ;;
  low)
	set_gpio ${GPS_POWER} 0
  ;;
  toggle)
	while [ true ]
	do
		set_gpio ${GPS_POWER} 0
		echo -n "GPS Power Int: "
		get_gpi ${GPS_POWER_INT}
		echo -n "GPS Power Sense: "
		get_gpi ${GPS_POWER_SENSE}
		sleep 1;
		set_gpio ${GPS_POWER} 1
		echo -n "GPS Power Int: "
		get_gpi ${GPS_POWER_INT}
		echo -n "GPS Power Sense: "
		get_gpi ${GPS_POWER_SENSE}
		sleep 1;
	done
  ;;
  
  *)
	echo "switchedpower.sh [high|low|toggle]"
	exit -1
  ;;
esac

exit 0
