import os 
import argparse
from intelhex import IntelHex

parser = argparse.ArgumentParser(description='Split a hexfile into onchip and offchip files')
parser.add_argument("file", help="hexfile to split",
                    type=str)
args = parser.parse_args()

path=os.path.split(args.file)[0]
filename=os.path.split(args.file)[1]

print "Processing [" + filename + "]"

print ("--stripping hexfile")
try:
    fp = open(path + "/" + filename, 'r')
    fpout = open('/var/volatile/' + filename + '.stripped', 'wb')
	
    line = fp.readline()
    cnt = 1
    output=0
    while line:
       if line.find(":02", 0, 3) != -1:
           output=1
       
       if output == 1:
#           print("Line {}: {}".format(cnt, line.strip()))
           fpout.write(line)

       line = fp.readline()
       cnt += 1
finally:
    fp.close()
    fpout.close()
	

#we load the hex file and then write it back out again incase the records are not in order
print ("--loading hexfile")
ih = IntelHex("/var/volatile/" + filename + ".stripped")
ih.padding = 0xFF # change padding byte
#ih.dump()


print "--writing hexfile ordered"
ih.write_hex_file("/var/volatile/" + filename + ".ordered")

print "--splitting on and off chip files"
offboard=0

try:
    fp = open('/var/volatile/' + filename + '.ordered', 'r')
    fponboard = open(path + "/" + filename + '.onboard', 'wb')
   	
    line = fp.readline()
    cnt = 1   
    while line:
       if line.find(":02000004680191",) != -1:  #address for offboard memory
           offboard=1
           fpoffboard = open(path + "/" + filename + '.offboard', 'wb')
       
       if offboard == 1:
           fpoffboard.write(line)
       else:
           fponboard.write(line)

       line = fp.readline()
       cnt += 1
finally:
    fp.close()
    fponboard.close()
    if offboard == 1:
        fpoffboard.close()	

print "--converting to binary"

#os.system("/usr/sbin/hex2bin /home/root/RavenAutoBoomXRT_P513V1_5_0_32_P0779000513-A.hex.onboard")
os.rename(path + "/" + filename + ".onboard", path + "/" + filename + ".onboard")

if offboard == 1:
    os.system("/usr/sbin/hex2bin " + path + "/" + filename + ".offboard")
    os.rename(path + "/" + filename + ".bin", path + "/" + filename + ".bin.offboard")
	