#!/usr/bin/python
#export $(dbus-launch)

import dbus, sys, gobject, threading, time, os, signal, json
import logging
import logging.handlers
from pprint import pprint
from dbus.mainloop.glib import DBusGMainLoop

alive = True

def ParseConfig():
	try:
	    if os.path.isfile('/etc/raven/ignition/ignition.conf'):
	        with open('/etc/raven/ignition/ignition.conf') as data_file:    
	            data = json.load(data_file)
	    shutdownDuration=data["shutdownTimerSeconds"]
	    if ( shutdownDuration < 15 ):
	        shutdownDuration = 15

	except Exception, e:
	    shutdownDuration = 7200

	return shutdownDuration

def shutdown():
	global alive
		
	logger = logging.getLogger('ignition-mon')
	logger.setLevel(logging.INFO)
	handler = logging.handlers.SysLogHandler(address = '/dev/log')
	logger.addHandler(handler)
	
	shutdownDuration = ParseConfig()
	
	logger.info("Shutting Down System in " + str(shutdownDuration/60) + " minutes")
	start = time.time()

	shutdown_end_time = start + shutdownDuration

	

	#give an update every second
	now = time.time()
	while ( now < shutdown_end_time):
		if alive:
			now = time.time()
			timeRemaining = shutdown_end_time - now
			#print "Timeout Remaining %d" % timeRemaining
			
			f = open('/tmp/shutdown_remaining', 'w')
			f.write('%d' % timeRemaining)
			f.close()
				
			time.sleep(5)
			
			updatedDuration = ParseConfig()
			if (updatedDuration != shutdownDuration):
				shutdownDuration = updatedDuration
				shutdown_end_time = start + shutdownDuration
				logger.info("Shutdown Duration Changed (" + str(shutdownDuration/60) + "): Remaining " + str((shutdown_end_time-now)/60) + " minutes")

		else:
			return
			
	logger.info("Ignition timeout: Shutting system down")	
	os.system("/sbin/shutdown -h now")
	
def handler(sender=None):
	global t
	global alive
	
	if '[dbus.Byte(1)]' == bytes([sigShutdownState()]):
		print time.strftime("%Y-%m-%d %H:%M")
		print "Shutdown signal Received %r" % sender
		if t.is_alive():
			print "Shutdown already in progress"
		else:
			t = threading.Thread(target=shutdown)
			t.daemon = True
			alive = True
			t.start()
	else:
		print time.strftime("%Y-%m-%d %H:%M")
		print "Shutdown Cancelled %r" % sender
		if t.is_alive():
			print "Stopping thread"
			alive = False
			t.join()
			os.remove('/tmp/shutdown_remaining')
	
DEFAULT_TIMER=7200
if os.path.exists('/etc/raven/platform'):
    with open('/etc/raven/platform') as f:
        platform = f.read()
	if "DART" in platform:
             DEFAULT_TIMER=0
    f.closed

if os.path.exists('/etc/raven/ignition/ignition.conf'):
    if os.path.getsize('/etc/raven/ignition/ignition.conf') < 4:
        print "Config corrupt, removing"
        os.remove('/etc/raven/ignition/ignition.conf')

if not os.path.exists('/etc/raven/ignition/ignition.conf'):
    os.system("mkdir -p /etc/raven/ignition/")
    f = open('/etc/raven/ignition/ignition.conf', 'w')
    f.write('{"version": 1, "shutdownTimerSeconds": ' + str(DEFAULT_TIMER) + '}')
    f.close()

dbus_loop = DBusGMainLoop()

bus = dbus.SystemBus(mainloop=dbus_loop)
sigs_interface = bus.get_object('com.raven.hardware.microcontroller.v1', '/com/raven/hardware/microcontroller/v1/sigs')
sigs_interface.connect_to_signal('sigShutdown', handler) 
sigShutdownState = sigs_interface.get_dbus_method('sigShutdown', 'com.raven.hardware.microcontroller.v1.sigs')

global t

if os.path.isfile('/tmp/shutdown_remaining'):
	os.remove('/tmp/shutdown_remaining')

t = threading.Thread(target=shutdown)
t.daemon = True
alive = True

if '[dbus.Byte(1)]' == bytes([sigShutdownState()]):
	t.start()

gobject.threads_init()
gobject.MainLoop().run()
