#!/usr/bin/python
import sys, gobject, threading, time, os, signal
from pprint import pprint

version=""
if os.path.isfile('/etc/raven/version'):
    with open('/etc/raven/version') as data_file:    
        version = data_file.readlines()
        version = [x.strip() for x in version]  
		
if "" == version:
    print("No version file found... exiting")
    sys.exit()

LOGDIR = "/var/log/runtime/"

if not os.path.exists(LOGDIR):
    os.makedirs(LOGDIR)
	
RUNTIMEFILE = LOGDIR + str(version[0])
BACKUPFILE= RUNTIMEFILE + "~"

#rotate files if there is a runtime file
if os.path.isfile(RUNTIMEFILE):
    if os.path.isfile(BACKUPFILE):
        os.remove(BACKUPFILE)
    os.rename(RUNTIMEFILE, BACKUPFILE)
	
#if there is a backup file, load its value
RUNTIME=0
if os.path.isfile(BACKUPFILE):
    with open(BACKUPFILE) as data_file:    
        RESUMETIME = data_file.readlines()
        RESUMETIME = [x.strip() for x in RESUMETIME]  
    if len(RESUMETIME) == 1:
        RUNTIME = int(RESUMETIME[0])
	
print("Starting runtime for version: " + str(version[0]) + " @ " + str(RUNTIME) + " seconds")

while ( 1 ):
    f = open(RUNTIMEFILE, 'w')
    f.write('%d' % RUNTIME)
    f.close()

    time.sleep(300)
	
    RUNTIME = RUNTIME + 300

#TODO:: do we need to capture exit conditions and close gracefully??
